/****************************************************************************
 * This file is part of the project AqFinance.
 * AqFinance (c) by 2013 Martin Preuss, all rights reserved.
 *
 * The license for this file can be found in the file COPYING which you
 * should have received along with this file.
 ****************************************************************************/


#ifndef AF_CATEGORY_FNS_H
#define AF_CATEGORY_FNS_H


#ifdef __cplusplus
extern "C" {
#endif


AE_API int AF_Report2_Category_AddDataPair(AF_REPORT2_CATEGORY *cat, AF_REPORT2_DATAPAIR *dp);

AE_API void AF_Report2_Category_Tree_MakeElementNewRoot(AF_REPORT2_CATEGORY_TREE *ct, AF_REPORT2_CATEGORY *cat);

AE_API int AF_Report2_Category_HasDataPairs(const AF_REPORT2_CATEGORY *cat);


AE_API void AF_Report2_Category_Tree_SubRuntimeFlags(AF_REPORT2_CATEGORY_TREE *ct, uint32_t flags);
AE_API void AF_Report2_Category_Tree_MarkCategoriesWithDataPairs(AF_REPORT2_CATEGORY_TREE *ct);
AE_API void AF_Report2_Category_MarkCategoriesWithDataPairs(AF_REPORT2_CATEGORY *cat);


AE_API AF_REPORT2_CATEGORY *AF_Report2_Category_Tree_FindHighestCommonRoot(AF_REPORT2_CATEGORY_TREE *ct);


AE_API void AF_Report2_Category_SumUpSubCategories(AF_REPORT2_CATEGORY *cat);
AE_API void AF_Report2_Category_Tree_SumUpCategories(AF_REPORT2_CATEGORY_TREE *ct);

AE_API void AF_Report2_Category_Tree_Dump(const AF_REPORT2_CATEGORY_TREE *ct);



#ifdef __cplusplus
}
#endif



#endif
