/****************************************************************************
 * This file is part of the project AqFinance.
 * AqFinance (c) by 2014 Martin Preuss, all rights reserved.
 *
 * The license for this file can be found in the file COPYING which you
 * should have received along with this file.
 ****************************************************************************/


#ifndef FF_EDITCOUNTERTYPE_HPP
#define FF_EDITCOUNTERTYPE_HPP


#include <fx.h>


#include <aqfinance/engine/book/ae_counter_type.h>


class FF_App;
class FF_DateEdit;
class FF_GroupTree;


class FF_EditCounterType: public FXDialogBox {
  FXDECLARE(FF_EditCounterType)

public:

  enum {
    ID_EDIT_NAME=FXDialogBox::ID_LAST,
    ID_EDIT_DESCRIPTION,
    ID_EDIT_XLABEL,
    ID_EDIT_YLABEL,
    ID_EDIT_ZLABEL,
    ID_EDIT_XUNITS,
    ID_EDIT_YUNITS,
    ID_EDIT_ZUNITS,
    ID_GROUP,
    ID_LAST
  };


  FF_EditCounterType(FF_App* a,
                     FXComposite *parent,
                     const FXString& title,
                     FXuint opts=DECOR_TITLE|DECOR_BORDER,
                     FXint x=0, FXint y=0, FXint w=0, FXint h=0,
                     FXint pl=0, FXint pr=0, FXint pt=0, FXint pb=0,
                     FXint hs=0, FXint vs=0);
  virtual ~FF_EditCounterType();


  static bool editCounterType(FF_App* app,
                              FXComposite *parent,
                              const FXString &title,
                              AE_COUNTER_TYPE *ct);

  void init();
  void fini();

  int checkGui(FXbool quiet);
  int toGui(const AE_COUNTER_TYPE *ct);
  int fromGui(AE_COUNTER_TYPE *ct);

  void create();
  FXint getDefaultHeight();

  long onCmdTextField(FXObject*, FXSelector, void *ptr);

  long onCmdAccept(FXObject*, FXSelector, void *ptr);
  long onCmdCancel(FXObject*, FXSelector, void *ptr);

protected:
  FF_EditCounterType();

  FF_App *m_app;

  FXTextField *m_nameEdit;
  FXTextField *m_descriptionEdit;
  FXTextField *m_xLabelEdit;
  FXTextField *m_yLabelEdit;
  FXTextField *m_zLabelEdit;
  FXTextField *m_xUnitsEdit;
  FXTextField *m_yUnitsEdit;
  FXTextField *m_zUnitsEdit;

  FF_GroupTree *m_groupTree;

};




#endif




