/****************************************************************************
 * This file is part of the project AqFinance.
 * AqFinance (c) by 2014 Martin Preuss, all rights reserved.
 *
 * The license for this file can be found in the file COPYING which you
 * should have received along with this file.
 ****************************************************************************/


#ifndef FF_EDITCOUNTERVALUE_HPP
#define FF_EDITCOUNTERVALUE_HPP


#include <fx.h>


#include <aqfinance/engine/book/ae_counter_value.h>


class FF_App;
class FF_DateEdit;


class FF_EditCounterValue: public FXDialogBox {
  FXDECLARE(FF_EditCounterValue)

public:

  enum {
    ID_EDIT_NAME=FXDialogBox::ID_LAST,
    ID_EDIT_DATE,
    ID_EDIT_XVALUE,
    ID_EDIT_YVALUE,
    ID_EDIT_ZVALUE,
    ID_EDIT_NOTE,
    ID_BUTTON_ANOTHER,
    ID_LAST
  };

  enum {
    OPTIONS_MULTI=0x04000000
  };


  FF_EditCounterValue(FF_App* a,
                      FXComposite *parent,
                      const FXString& title,
                      FXuint opts=DECOR_TITLE|DECOR_BORDER,
                      FXint x=0, FXint y=0, FXint w=0, FXint h=0,
                      FXint pl=0, FXint pr=0, FXint pt=0, FXint pb=0,
                      FXint hs=0, FXint vs=0);
  virtual ~FF_EditCounterValue();


  static bool editCounterValue(FF_App* app,
                               FXComposite *parent,
                               const FXString &title,
                               AE_COUNTER_VALUE *cv);

  static bool createCounterValues(FF_App* app,
                                  FXComposite *parent,
                                  const FXString &title,
                                  const AE_COUNTER_VALUE *origTmpl);

  bool wantAnother() const { return m_wantAnother;};


  void init();
  void fini();

  int checkGui(FXbool quiet);
  int toGui(const AE_COUNTER_VALUE *cv);
  int fromGui(AE_COUNTER_VALUE *cv);

  void create();
  FXint getDefaultHeight();

  long onCmdTextField(FXObject*, FXSelector, void *ptr);

  long onCmdAccept(FXObject*, FXSelector, void *ptr);
  long onCmdCancel(FXObject*, FXSelector, void *ptr);
  long onCmdWantAnother(FXObject*, FXSelector, void *ptr);

protected:
  FF_EditCounterValue();

  int _strToValue(FXbool needed, const FXString &str, AQDB_VALUE **pValue, int *pUnits);
  bool _checkValueAndUnits(FXbool quiet, FXbool needed, FXTextField *tf, const FXString &errorTitle);


  FF_App *m_app;

  FF_DateEdit *m_dateEdit;
  FXTextField *m_xValueEdit;
  FXTextField *m_yValueEdit;
  FXTextField *m_zValueEdit;

  FXTextField *m_noteEdit;

  bool m_wantAnother;
  FXButton *m_anotherButton;


};




#endif




