/****************************************************************************
 * This file is part of the project AqFinance.
 * AqFinance (c) by 2019 Martin Preuss, all rights reserved.
 *
 * The license for this file can be found in the file COPYING which you
 * should have received along with this file.
 ****************************************************************************/


#ifndef FF_TANIMAGEDIALOG_HPP
#define FF_TANIMAGEDIALOG_HPP


#include <fx.h>

class FF_App;
class FOX16_HtmlLabel;



class FF_TanImageDialog: public FXDialogBox {
  FXDECLARE(FF_TanImageDialog)

public:

  enum {
    ID_EDIT_TAN=FXDialogBox::ID_LAST,
    ID_LAST
  };

  FF_TanImageDialog(FF_App* a,
                   FXWindow *parent,
                   const FXString& title,
                   FXuint opts=DECOR_TITLE|DECOR_BORDER,
                   FXint x=0, FXint y=0, FXint w=0, FXint h=0,
                   FXint pl=0, FXint pr=0, FXint pt=0, FXint pb=0,
                   FXint hs=0, FXint vs=0);
  ~FF_TanImageDialog();

  static bool getTan(FF_App* app,
                     FXWindow *parent,
                     const FXString &title,
                     const FXString &message,
                     FXImage *image,
                     int minLen,
                     int maxLen,
                     FXString &response);


  void init();
  void fini();

  long onCmdAccept(FXObject*, FXSelector, void *ptr);
  long onCmdCancel(FXObject*, FXSelector, void *ptr);

  long onCmdTan(FXObject*, FXSelector, void *ptr);
  long onChgTan(FXObject*, FXSelector, void *ptr);

protected:
  FF_TanImageDialog();

  FF_App *m_app;
  int m_tanMinLen;
  int m_tanMaxLen;
  FOX16_HtmlLabel *m_label;

  FXImageFrame *m_imageWidget;
  FXTextField *m_tanInput;
  FXButton *m_okButton;

};




#endif




