/****************************************************************************
 * This file is part of the project AqFinance.
 * AqFinance (c) by 2014 Martin Preuss, all rights reserved.
 *
 * The license for this file can be found in the file COPYING which you
 * should have received along with this file.
 ****************************************************************************/


#ifndef FF_VIEW_REPORT2_CAT_DB_HPP
#define FF_VIEW_REPORT2_CAT_DB_HPP


#include <fx.h>


#include <aqfinance/report2/af_report2_settings.h>


class FF_App;
class FF_GroupView;


class FF_View_Report2CategoryDb: public FXHorizontalFrame {
  FXDECLARE(FF_View_Report2CategoryDb)

public:

  enum {
    ID_EDIT_NAME=FXHorizontalFrame::ID_LAST,
    ID_EDIT_DESCR,
    ID_VIEW_GROUP,

    ID_LAST
  };

public:
  FF_View_Report2CategoryDb(FXComposite *p,
                           FXuint opts=0,
                           FXint x=0, FXint y=0, FXint w=0, FXint h=0);
  ~FF_View_Report2CategoryDb();

  void init(GWEN_DB_NODE *db);
  void fini(GWEN_DB_NODE *db);

  void toGui(const AF_REPORT2_SETTINGS *settings);
  bool fromGui(AF_REPORT2_SETTINGS *settings);


protected:
  FF_View_Report2CategoryDb();

  FXTextField *m_nameEdit;
  FXTextField *m_descrEdit;

  FF_GroupView *m_groupView;

};





#endif


