/****************************************************************************
 * This file is part of the project AqFinance.
 * AqFinance (c) by 2018 Martin Preuss, all rights reserved.
 *
 * The license for this file can be found in the file COPYING which you
 * should have received along with this file.
 ****************************************************************************/

#ifndef FF_BANKINGJOBTREE_HPP
#define FF_BANKINGJOBTREE_HPP

#include "ff_grouptree.hpp"

#include <fx.h>

#include <aqbanking/types/transaction.h>



class FF_BankingJobTreeItem: public FF_GroupTreeItem {
public:
  FF_BankingJobTreeItem(AB_TRANSACTION *j, FXIcon* oi=NULL, FXIcon* ci=NULL, void* ptr=NULL);

  virtual ~FF_BankingJobTreeItem();

  AB_TRANSACTION *getBankingJob() const { return m_bankingJob;};

protected:
  FXString createJobDetails(const AB_TRANSACTION *j);

  AB_TRANSACTION *m_bankingJob;
};



class FF_BankingJobTree: public FF_GroupTree {

public:
  FF_BankingJobTree(FXComposite *p, FXObject* tgt=NULL, FXSelector sel=0, FXuint opts=0,
                    FXint x=0, FXint y=0, FXint w=0, FXint h=0);

  virtual ~FF_BankingJobTree();

  FF_BankingJobTreeItem *findBankingJobItem(AQDB_ID id);
  FF_BankingJobTreeItem *findBankingJobItem(FF_GroupTreeItem *grItem, AQDB_ID id);

  void addJob(AB_TRANSACTION *j);

  AB_TRANSACTION *getCurrentBankingJob();
  AB_TRANSACTION *getFirstSelectedBankingJob();
  void getSelectedBankingJobs(AB_TRANSACTION_LIST2 *al);

  void selectBankingJob(AQDB_ID id, bool b);
  void makeBankingJobVisible(AQDB_ID id);

  void create();

protected:
  FF_BankingJobTree();

};



#endif




